# -*- coding: utf8 -*-
from __future__ import unicode_literals

import datetime
import time

from driverng.protocol import VoidProtocol


class AlereProtocol(VoidProtocol):
    ACK = b"""<?xml version="1.0" encoding="utf-8"?><ACK.R01><HDR><HDR.control_id V="%(control_id)s" /><HDR.version_id V="%(version_id)s" /><HDR.creation_dttm V="%(creation_dttm)s" /></HDR><ACK><ACK.type_cd V="%(type_cd)s" /><ACK.ack_control_id V="%(ack_control_id)s" /></ACK></ACK.R01>"""

    def get_ack_message(self, payload, date=None, control_id=None):
        date = date or datetime.datetime.now()
        control_id = b"%d" % int(time.time() * 1000) if not control_id else control_id
        context = {
            b"control_id": control_id,
            b"version_id": b"POCT1",
            b"creation_dttm": date.strftime("%Y%m%d%H%M%S").encode(),
            b"type_cd": b"AA",
            b"ack_control_id": control_id,
        }
        return self.ACK % context

    def recv_trames(self):
        self.write(self.get_ack_message(self))
        data = self.read(size=None)
        return data.replace(b"<A>", b"\r")
